#!/usr/bin/python
# -*- coding: utf-8 -*-

# attention: pour les accents, ce fichier doit être impérativement
#      lu et modifié sous éditeur avec encodage UTF-8

################################################################
######                                                    ######
######                    CALCULEXT                       ######
######                                                    ######
######         ===> Calculatrice Extensible <===          ######
######                                                    ######
######                   Version 1.30                     ######
######                                                    ######
################################################################

# Copyright (C) 2008 Jean-Paul Vidal dit "Tyrtamos" — Tous droits réservés.
#   Logiciel distribué gratuitement sur le site <http://linux.jpvweb.com>
#
#   Ce programme est un logiciel libre. Vous pouvez le redistribuer ou le
#   modifier suivant les termes de la "GNU General Public License" version 3,
#   telle que publiée par la Free Software Foundation.
#
#   Ce programme est distribué dans l’espoir qu’il vous sera utile, mais SANS
#   AUCUNE GARANTIE : sans même la garantie implicite de COMMERCIALISABILITÉ
#   ni d’ADÉQUATION À UN OBJECTIF PARTICULIER. Consultez la Licence Générale
#   Publique GNU pour plus de détails.
#
#   Ce programme doit être distribué avec une copie de la
#   License Générale Publique GNU (fichier license.html).
#   Si ce n’est pas le cas, consultez: <http://www.gnu.org/licenses/gpl.html>.

##################################################################
# Importation des modules nécessaires au fonctionnement de la calculatrice

# Attention: configuration volontairement inhabituelle pour python:
# les divisions entre 2 entiers seront décimales et pas entières!
# par exemple: 10/3 donnera "3.33333333333333" et pas "3"
# (les divisions entières seront désormais faites avec "//")
#
from __future__ import division

# Importation des modules système
#
import Tkinter
import tkFont
import os
import sys
import threading
import webbrowser
import time

# Importation des modules nécessaires aux calculs
#
from math import *
from decimal import *
from random import *
import cmath
import locale
import datetime

# importation des modules additionnels
#    ajoutez ici les modules que vous avez créés
#    et mettez en commentaire ceux que vous n'utilisez pas
#
from bibgene import *
from arithmetique import *
from combinatoire import *
from probabilite import *
from credit import *
from temps import *

##################################################################
# Déclaration des variables globales

# préparation du menu flottant, appelé par un clic droit sur la zone de saisie
chmenu=(
        ("Opérateurs", "+", "-", "*", "/", "//", "**", "%", "",
            "and", "or", "not", "<", "<=", ">", ">=", "!=", "",
            "&", "|", "^", "~", ">>", "<<"
            ),
        ("Conversions", "int(x)", "long(x)", "float(x)", "str(x)",
            "repr(x)", "list(x)", "",
            "hex(n)", "oct(n)", "dec2bin(n, B=0)", "dec2bins(n, B=8)",
            "bin2dec(chaîne binaire)", "bin2decs(chaîne binaire, B=8)", "",
            "ord(caractère ASCII)", "chr(num ASCII)", "",
            "degrees(x)", "radians(x)",
            "deg2dms(degrés décimaux)", "dms2deg(liste [deg,min,sec])"
            ),
        ("Général", "aide(fonction)", "sto('X',expression)", "round(x,n)", "arrond(x,n)",
             "len(S)", "[]", "[:]", "lambda :", "map(fonction,[paramètres])",
             "jeuxdessais(n,L1,L2)", "volcuve(h,d,v)", "mdp2hex(ch)", "hex2mdp(ch)", "random()"
             ),
        ("Fonct. transcendantes", "pi", "e", "",
            "pow(x,y)", "sqrt(x)", "exp(x)", "log(x)", "log10(x)", "hypot( x, y)", "",
            "sin(r)", "cos(r)", "tan(x)", "",
            "asin(x)", "acos(x)", "atan(x)", "",
            "sinh(x)", "cosh(x)", "tanh(x)"
            ),
        ("Module 'decimal'", "Decimal()", "precisiondecimal(n)",
            ),
        ("Complexes", "complex(nb réel, nb imaginaire)", ".real", ".imag",
            ".conjugate()", "",
            "cmath.sqrt(x)", "cmath.exp(x)", "cmath.log(x)", "cmath.log10(x)", "",
            "cmath.sin(x)", "cmath.cos(x)", "cmath.tan(x)", "",
            "cmath.asin(x)", "cmath.acos(x)", "cmath.atan(x)", "",
            "cmath.sinh(x)", "cmath.cosh(x)", "cmath.tanh(x)", "",
            "cmath.asinh(x)", "cmath.acosh(x)", "cmath.atanh(x)"
            ),
        ("Arithmétique", "fact(n)", "pgcd(a,b)", "ppcm(a,b)", "facteurs(n)",
            "estpremier(n)", "premiers(n)"
            ),
        ("Combinatoire", "permut(n)", "arrang(n,p)", "combin(n,p)"
            ),
        ("Probabilités", "binom(k,n,p)", "binomcum(k,n,p)", "hypgeo(k,n,g,t)",
            "hypgeocum(k,n,g,t)", "", "pgaussred(x)", "pgauss(x,m,s)", "xgaussred(p)",
            "xgauss(p,m,s)", "hgaussred(n=1)", "hgauss(m,s,n=1)"
            ),
        ("Crédit", "menscredit(capital, intérêt%/an, nb de mois)",
            "moiscredit(capital, intérêt%/an, mensualité)",
            "capcredit(intérêt%/an, mensualité, nb de mois)",
            "intcredit(capital, mensualité, nb de mois)",
            "coutcredit(capital, mensualité, nb de mois, sup=0)"
            ),
        ("Dates et heures", "tempsordi()", "tempsntp(sntp='ntp.univ-lyon1.fr')", "",
            "cetteheure()", "sec2hms(secdec)", "",
            "cejour()", "bissextile(an)", "nbjoursan(an)", "numjouran(D)", "datenumjouran(n,an)",
            "diffdate(D1,D2)", "adddate(D,n)", "numjoursem(D)", "joursem(D)", "lundi(D)", "",
            "paques(an)", "ascension(an)", "pentecote(an)", "mardigras(an)",
            "rameaux(an)", "feries(an,sd=0)"
            ),
        ("[Priorités opér.]", "$chaîne", "$[] : liste", "$() : parenthèses",
            "$X() : appel de fonction", "$X[i1:i2] : découpage ",
            "$X[i] : indexation ", "$** : puissance: ", "$~ : non binaire",
            "$+, - : op. unaires", "$*, /, //, %", "$+, -",
            "$<<, >> : op. binaire", "$& : op. binaire", "$^ : op. binaire",
            "$| : op. binaire", "$<, <=, >, >= : comparaison",
            "$==, != : comparaison", "$is, not is : identité",
            "$in, not in : appartenance", "$not : op. logique",
            "$and : op. logique", "$or : op. logique", "$fonction lambda"
            ),
        ("[A propos]", "", "$  - CALCULEXT version 1.30 -  ",
         "$   Calculatrice extensible", "$     Tyrtamos déc 2007",
         "$   http://linux.jpvweb.com", ""
            )
        )

# variable globale qui devient True en cas de demande d'arrêt du calcul
arretcalcul=False
# drapeau qui indique si un calcul est en cours en tâche de fond (=dans un thread)
encourscalcul=False
# pile historique pour conserver les expressions précédentes ainsi que le dernier résultat
pile=[]
courpile=-1
# mode d'affichage pour les nombres à virgule flottante (voir fonction d'affichage)
nbchiffres=-15
# variable globale qui portera le thread de calcul (accès nécessaire dans les modules)
calc=None
# variables globales qui porteront la fenêtre et les contrôles graphiques (widgets)
fen=None
app=None

###############################################################################
# dit si un nombre est "entier", ou "entier long", ou "flottant sans décimale" (renvoie True ou False)
#
def estentier(n):
    """estentier(n): dit si un nombre est entier ou 'flottant sans décimale' (renvoie True ou False)"""
    if (type(n)==int) or (type(n)==long) or ((type(n)==float) and (int(n)==n)):
        return True
    return False

###############################################################################
# dit si un nombre est entier, long ou flottant (renvoie True ou False)
#
def estnombre(n):
    """estnombre(n): dit si un nombre est entier, long ou flottant (renvoie True ou False)"""
    if (type(n)==int) or (type(n)==long) or (type(n)==float):
        return True
    return False

###############################################################################
# permet de changer la précision du module decimal
#
def precisiondecimal(n=28):
    """precisiondecimal(n): permet de changer la précision du module decimal (28 par défaut)"""
    # Vérif des données
    if (not estentier(n)) or (n<0):
        raise ValueError ("erreur precisiondecimal(n=28): n, optionnel, doit être un entier positif ou nul")
    # Calcul
    getcontext().prec=n
    return n

##################################################################
# Change le mode d'affichage de la virgule des nombres réels (type float) -15<=n<=15
#   si nbchiffres<0 => affichage intelligent à "nbchiffres" chiffres significatifs
#   sinon, affichage à "nbchiffres" chiffres après la virgule
#
def precision(n=-15):
    """precision(n=-15): change le mode d'affichage des nombres réels (type float) -15<=n<=15"""
    global nbchiffres
    nbchiffres=n
    if nbchiffres<0:
        return "affichage intelligent à "+str(abs(nbchiffres))+" chiffres significatifs"
    else:
        return "affichage à "+str(nbchiffres)+" chiffres après la virgule"

##################################################################
# Fonction récursive d'affichage des nombres réels à virgule flottante
# x: n'importe quel objet python à afficher, y compris liste, tuples et complexes
# n: définit le mode d'affichage des nombres flottants à utiliser:
#   si n<0 => affichage intelligent à n chiffres significatifs (defaut=-15)
#   sinon, affichage à n chiffres après la virgule
#
def arrond(x,n=-15):
    """arrond(x,n=-15): affichage des nombres réels à virgule flottante avec -15<=n<=15 (défaut n=-15)"""
    if type(x)==float:
        if n<0:
            f="%."+str(abs(n))+"g"
            return f % x
        else:
            f="%."+str(n)+"f"
            return f % x
    elif type(x)==list:
        L = "["
        if len(x)>0:
            for i in range(0,len(x)):
                L=L+str(arrond(x[i],n))+","
            L=L[0:len(L)-1]
        L=L+"]"
        return L
    elif type(x)==tuple:
        L = "("
        if len(x)>0:
            for i in range(0,len(x)):
                L=L+str(arrond(x[i],n))+","
            L=L[0:len(L)-1]
        L=L+")"
        return L
    elif type(x)==complex:
        L="("+arrond(x.real,n)
        if x.imag>=0:
            L=L+"+"
        L=L+arrond(x.imag,n)+"j)"
        return L
    elif type(x)==str:
        return '"%s"' % x
    else:
        return "%r" % x

##################################################################
# Fonction récursive d'affichage des nombres réels à virgule flottante
# x: n'importe quel objet python à afficher, y compris liste, tuples et complexes
# nbchiffres: variable globale qui définit le mode d'affichage courant des nombres réels
#
def affiche(x):
    global nbchiffres
    return arrond(x,nbchiffres)

##################################################################
# Création interactive de variables supplémentaires
# ex: sto("toto",120+3) crée la variable X=toto (si elle n'existait pas)
#   et lui affecte le résultat de l'expression 120+3, c'est à dire 123.
# Cette variable toto devient utilisable dans les calcules suivants
#
# -> X doit être un nom de variable valide entouré de guillemets ou d'apostrophes:
#      (1er car=une lettre; les car suivants: lettre, chiffre ou "_")
# -> E est une valeur ou une expression de n'importe quel type
#
# Le Le résultat de E est renvoyé comme résultat de sto. On peut donc utiliser sto
#     à l'intérieur d'une expression comme: 2*sto("x",123)/25
#
# Attention aux risques de conflit avec les variables déjà existantes
# => testez avant: si l'exécution de toto (sans guillemet) donne 'erreur',
#     alors, la variable toto n'existe pas et vous pouvez la créer sans pb
#
def sto(X,E):
    """sto(X,E): affecte le résultat de l'expression E à la variable X (ex: 'toto') qui est créée si elle n'existait pas"""
    globals()[X]=E
    return E

##############################################################
# Affiche l'aide sur une fonction donnée
#
def aide(fn):
    """aide(fn): affiche l'aide sur une fonction donnée fn"""
    return fn.__doc__.replace("\n"," ")

##################################################################
# Fonction pour mettre la calculatrice au centre de l'écran
#
def centrefenetre(fen):
    """"""
    fen.update_idletasks()
    geo=fen.geometry()
    x=geo.find('x',0)
    tx=geo[0:x]       # taille horizontale
    y=geo.find('+',x+1)
    ty=geo[x+1:y]     # taille verticale
    xecran=fen.winfo_screenwidth()
    yecran=fen.winfo_screenheight()
    x0=(xecran-int(tx))//2
    y0=(yecran-int(ty))//2
    fen.geometry("+" + str(x0) + "+" + str(y0))

##################################################################
# Fonction pour afficher la durée de chaque calcul
#  calcule la durée en "h mn s" à partir des secondes décimales
#  ex: afficheduree(55365.123654789) => "15h 22mn 45.124s"
#  - n'affiche les heures que si elles ne sont pas nulles
#  - n'affiche les minutes que si les heures et les minutes ne sont pas nulles
#  - les secondes sont toujours affichées en secondes décimales (millisecondes)
#  - si durée inférieure à la milliseconde, affiche "< 0.001s"
#
def afficheduree(sd):
    """afficheduree(sd): renvoie la durée en "h mn s" à partir des secondes décimales"""
    if sd<0.001:
        return "< 0.001s"
    h=0
    m=0
    s=sd
    if s>=60:
        m=int(s/60)
        s=s-m*60
        if m>=60:
            h=int(m/60)
            m=m-h*60
    hch=str(h)
    mch=str(m)
    sch=str(round(s,3))
    if h>0:
        hms=hch+"h "+mch+"mn "+sch+"s"
    elif m>0:
        hms=mch+"mn "+sch+"s"
    else:
        hms=sch+"s"
    return hms

##################################################################
# les fonctions longues testent ici pour déclencher l'arrêt du calcul si demandé
#
def testarretcalcul():
    global arretcalcul
    if arretcalcul==True:
        raise ValueError ("arrêt du calcul demandé")

##################################################################
# Création de la classe "Calcul" dans un thread (=processus "leger")
#   pour calculer les expressions en tâche de fond
#
class Calcul(threading.Thread):
    """"""
    # met en place le thread
    def __init__(self,expr):
        # initialise la classe ancêtre dont il est dérivé
        threading.Thread.__init__(self)
        # stocke l'expression à calculer
        self.expression=expr

    # lance le calcul en tâche de fond (run() est lancé par "calc.start()")
    def run(self):
        global app, pile, courpile, encourscalcul
        debutcalcul=time.time()
        try:
            # fonction principale de calcul et de formatage du résultat
            result=affiche(eval(self.expression))
            # empilage de l'expression dans la pile historique
            if len(pile)==0:
                pile.append(self.expression)
            else:
                pile[len(pile)-1]=self.expression
            # et empilage du dernier résultat
            pile.append(result)
            # courpile doit pointer sur la dernière expression empilée (et pas sur son résultat)
            courpile=len(pile)-2
        except:
            # Recupération du message d'erreur (erreur interne ou déclenchée par "raise")
            result="%s" % sys.exc_info()[1]
        # affichage du résultat ou du message d'erreur ou du message d'arrêt demandé
        app.resultat.insert(0,result)
        # Affichage du temps de calcul
        app.duree.config(text="["+afficheduree(time.time()-debutcalcul)+"]")
        # ré-active la zone de saisie qui avait été désactivée au lancement du calcul
        app.saisie.config(state=Tkinter.NORMAL)
        # met le focus sur la zone de saisie
        app.saisie.focus_set()
        # permet d'indiquer que le thread est terminé
        encourscalcul=False

##################################################################
# Création de la classe "Calculext"
#
class Calculext(Tkinter.Frame):
    """"""

    def __init__(self, master=None):
        global calc
        # exécution du constructeur initial de la classe Tkinter.Frame
        Tkinter.Frame.__init__(self, master, background="grey")

        # prépa config police de caractère
        police=tkFont.Font(self)
        police.config(size=12, family='Courier')

        # création d'un layout_manager sur self
        self.grid()

        # création de la zone de saisie des expressions à calculer
        self.saisie=Tkinter.Entry(self,  background="white", width=72)
        self.saisie.config(font=police)
        self.saisie.event_add ( "<<gocalc>>", "<Return>","<KP_Enter>")
        self.saisie.bind("<<gocalc>>", self.calculer)
        self.saisie.bind("<Escape>", self.effacer)
        self.saisie.bind("<F1>", self.aider)
        self.saisie.bind("<Up>", self.exprprec)
        self.saisie.bind("<Down>", self.exprsuiv)
        self.saisie.bind("<F2>", self.stopper)
        self.saisie.bind("<Button-3>", self.menupopup)
        self.saisie.bind("<Control-r>", self.sauveresultat)
        self.saisie.bind("<Control-e>", self.sauveexpressions)
        self.saisie.grid(row=0,column=0, columnspan=4,padx=3, pady=3)

        # création du texte "Résultat="
        self.egal=Tkinter.Label(self, background="grey", text="Résultat=")
        self.egal.config(font=police)
        self.egal.grid(row=1,column=0, sticky="we", padx=3, pady=3)

        # création de la zone pour l'affichage du résultat
        self.resultat=Tkinter.Entry(self, background="yellow")
        self.resultat.config(font=police)
        self.resultat.event_add ( "<<gocalc2>>", "<Return>","<KP_Enter>")
        self.resultat.bind("<<gocalc2>>", self.calculer)
        self.resultat.bind("<Escape>", self.effacer)
        self.resultat.bind("<F1>", self.aider)
        self.resultat.bind("<Up>", self.exprprec)
        self.resultat.bind("<Down>", self.exprsuiv)
        self.resultat.bind("<F2>", self.stopper)
        self.resultat.bind("<Control-r>", self.sauveresultat)
        self.resultat.bind("<Control-e>", self.sauveexpressions)
        self.resultat.grid(row=1,column=1, columnspan=3, sticky="we",padx=3, pady=3)

        # création de la zone pour l'affichage du temps de calcul
        self.duree=Tkinter.Label(self, background="grey", text="", width=10)
        self.duree.config(font=police)
        self.duree.grid(row=2,column=0, sticky="we", padx=3, pady=3)

        # création d'un ascenseur horizontal pour consulter plus facilement les lignes trop longues de résultat
        self.resultatScroll = Tkinter.Scrollbar ( self, orient=Tkinter.HORIZONTAL, command=self.scrollRoutine)
        self.resultatScroll.grid(row=2, column=1, columnspan=3, sticky="we", padx=3, pady=3)
        self.resultat["xscrollcommand"] = self.resultatScroll.set

        # création du bouton "effacer"
        self.efface=Tkinter.Button(self, text="Effacer ", background="#66ccff", activebackground="#3399ff", command=lambda:self.effacer(self))
        self.efface.config(font=police)
        self.efface.grid(row=3, column=0, padx=3, pady=3, sticky="we")

        # création du bouton "aide"
        self.aide=Tkinter.Button(self, text="  Aide  ", background="#66ccff", activebackground="#3399ff", command=lambda:self.aider(self))
        self.aide.config(font=police)
        self.aide.grid(row=3, column=1, padx=3, pady=3, sticky="we")

        # création du bouton "calculer"
        self.calc=Tkinter.Button(self, text="Calculer", background="#66ccff", activebackground="#3399ff", command=lambda:self.calculer(self))
        self.calc.config(font=police)
        self.calc.grid(row=3, column=2, padx=3, pady=3, sticky="we")

        # création du bouton "stopper"
        self.stoppe=Tkinter.Button(self, text="Stopper ", background="#66ccff", activebackground="#3399ff", command=lambda:self.stopper(self))
        self.stoppe.config(font=police)
        self.stoppe.grid(row=3, column=3, padx=3, pady=3, sticky="we")

        # Construction du menu pop-up qui apparaitra au clic droit sur la ligne de saisie
        self.menuflottant = Tkinter.Menu(self.saisie, tearoff = 0, bg="lightblue",font=police)
        self.menu=[]
        for k in range(0, len(chmenu)):
            self.menu.append(Tkinter.Menu(self.menuflottant, tearoff=0, bg="lightblue", font=police))
            for i in range(1, len(chmenu[k])):
                if chmenu[k][i]=="":
                    # si l'item est vide, on met un séparateur
                    self.menu[k].add_separator()
                elif chmenu[k][i][0]=="$":
                    # si l'item commence par "$", on n'affiche pas le "$" dans le menu et il n'y aura pas d'insertion
                    self.menu[k].add_command(label=chmenu[k][i][1:], command=lambda x=k, y=i: self.execmenu(chmenu[x][y]))
                else:
                    self.menu[k].add_command(label=chmenu[k][i], command=lambda x=k, y=i: self.execmenu(chmenu[x][y]))
            self. menuflottant.add_cascade(label=chmenu[k][0], menu=self.menu[k])

        # fin de la création de la calculatrice: mettre le focus sur la zone de saisie
        self.saisie.focus_set()

    def scrollRoutine(self, *L):
        # Assure la synchro entre l'ascenseur horizontal et la ligne des résultats
        oper=L[0]
        combien=L[1]
        if oper=="scroll":
            units=L[2]
            self.resultat.xview_scroll(combien, units)
        elif oper=="moveto":
            self.resultat.xview_moveto(combien)

    def calculer(self,event):
        # lance le calcul de l'expression en tâche de fond (thread)
        global calc, arretcalcul, encourscalcul
        if (self.saisie.get()<>"") and (not encourscalcul):
            # désactivation de la zone de saisie pour empêcher le lancement d'un nouveau calcul
            self.saisie.config(state=Tkinter.DISABLED)
            # effacement zones d'affichage pendant le nouveau calcul
            self.resultat.delete(0,Tkinter.END)
            self.duree.config(text="")
            # initialisation du thread de calcul
            calc=Calcul(self.saisie.get())
            calc.setDaemon(True)
            # initialisation  des variables globales utilitaires
            arretcalcul=False
            encourscalcul=True
            # lancement du calcul en tâche de fond
            calc.start()

    def stopper(self,event):
        # permet à l'utilisateur d'ordonner l'arrêt d'un calcul trop long
        global arretcalcul, encourscalcul
        if encourscalcul:
            # demande d'arrêt du calcul en cours
            arretcalcul=True

    def sauveresultat(self,event):
        # sauve le dernier résultat calculé sur disque à la fin du fichier resultat.txt
        global pile, encourscalcul
        if (not encourscalcul) and (len(pile)>0):
            # trouve l'emplacement du fichier resultat.txt
            fichier=os.path.dirname(sys.argv[0]) + os.sep + 'resultat.txt'
            y=pile[len(pile)-1]
            # tentative d'ouverture en mode ajout
            try:
                f=open(fichier,'a')
            except:
                self.resultat.delete(0,Tkinter.END)
                self.resultat.insert(0,"échec: impossible d'ouvrir en écriture le fichier resultat.txt")
                return None
            # tentative d'écriture de la donnée à la fin du fichier
            try:
                f.writelines(y)
                f.write('\n')
                f.close()
            except:
                f.close()
                self.resultat.delete(0,Tkinter.END)
                self.resultat.insert(0,"échec: impossible d'écrire dans le fichier resultat.txt")
            return None

    # sauve la pile des expressions et du dernier résultat sur disque à la fin du fichier resultat.txt
    def sauveexpressions(self,event):
        global pile, encourscalcul
        if (not encourscalcul) and (len(pile)>0):
            # trouve l'emplacement du fichier resultat.txt
            fichier=os.path.dirname(sys.argv[0]) + os.sep + 'resultat.txt'
            y="%s" % pile
            # tentative d'ouverture du fichier en mode ajout
            try:
                f=open(fichier,'a')
            except:
                self.resultat.delete(0,Tkinter.END)
                self.resultat.insert(0,"échec: impossible d'ouvrir en écriture le fichier resultat.txt")
                return None
            # tentative d'écriture de la donnée à la fin du fichier
            try:
                f.writelines(y)
                f.write('\n')
                f.close()
            except:
                f.close()
                self.resultat.delete(0,Tkinter.END)
                self.resultat.insert(0,"échec: impossible d'écrire dans le fichier resultat.txt")
            return None

    def effacer(self,event):
        # efface les 3 zones (saisie, résultat et durée)
        global encourscalcul
        if not encourscalcul:
            self.saisie.delete(0,Tkinter.END)
            self.resultat.delete(0,Tkinter.END)
            self.duree.config(text="")
            self.saisie.focus_set()

    def aider(self,event):
        # affiche la page d'aide dans le navigateur web par défaut
        # cette page doit être dans le même répertoire que la calculatrice
        rep=os.path.dirname(sys.argv[0]) + os.sep + 'calculext.html'
        webbrowser.open(rep)
        self.saisie.focus_set()

    def exprprec(self,event):
        # touche 'flèche en haut' permet la remontée dans la pile des formules
        global pile, courpile
        if courpile>0:
            courpile=courpile-1
            self.saisie.delete(0,Tkinter.END)
            self.saisie.insert(0,pile[courpile])
        self.saisie.focus_set()

    def exprsuiv(self,event):
        # touche 'flèche en bas' permet le rappel du résultat ou descente dans la pile des formules
        global pile, courpile
        if courpile<(len(pile)-1):
            courpile=courpile+1
            self.saisie.delete(0,Tkinter.END)
            self.saisie.insert(0,pile[courpile])
        self.saisie.focus_set()

    def menupopup(self, evt):
        # déclenche l'affichage du menu pop-up à l'endroit de la souris sur la ligne de saisie
        ycoord = self.saisie.winfo_pointery()
        xcoord = self.saisie.winfo_pointerx()
        self.menuflottant.tk_popup(xcoord, ycoord)

    def execmenu(self,ch):
        # exécuté quand il y a eu sélection d'un item du menu flottant 2ème niveau
        # quand l'item commence par "$", n'insère rien
        if ch[0]!="$":
            # élimination des éventuels arguments entre parenthèses s'il y a des parenthèses
            ip1=ch.find("(")
            if ip1>=0:
                ip2=ch.rfind(")")
                ch=ch[0:ip1+1] + ch[ip2:]
            # lecture de la position du curseur et de l'éventuel début d'une sélection dans la saisie
            a=self.saisie.index(Tkinter.ANCHOR)
            i=self.saisie.index(Tkinter.INSERT)
            if i<a:
                # si la sélection a été faite à l'envers (de droite à gauche), inverser a et i pour que i>a
                a,i=i,a
            if ip1>=0:
                # = la fonction a une parenthèse
                if a!=i:
                    # = il y a une sélection en cours => la sélection sera placée entre les parenthèses
                    s=self.saisie.get()
                    x=s[0:a] + ch[0:-1] + s[a:i] + ")" + s[i:]
                    self.saisie.delete(0,Tkinter.END)
                    self.saisie.insert(0, x)
                else:
                    # = il n'y a pas de sélection en cours => insertion normale
                    self.saisie.insert(Tkinter.INSERT, ch)
                # sélection ou pas, curseur positionné juste avant la parenthèse fermante
                self.saisie.icursor(i+len(ch)-1)
            else:
                # la fonction n'a pas de parenthèse => insertion sans tenir compte de la sélection
                self.saisie.insert(Tkinter.INSERT, ch)
                # curseur positionné après la partie insérée
                self.saisie.icursor(i+len(ch))

##############################################################################
# lancement, affichage au centre de l'écran et exécution de la calculatrice
#
if __name__ == "__main__":
    sys.setcheckinterval(0)
    fen=Tkinter.Tk()
    fen.title("CALCULEXT v1.30  - Calculatrice scientifique extensible -")
    app=Calculext(fen)
    centrefenetre(fen)
    fen.resizable(width=False, height=False)
    fen.mainloop()
